#!/usr/bin/python2.4
#    Copyright 2009 Alex Joni
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# graphic model of a Unimate Puma 560
# according to the dimensions from: http://www.juve.ro/blog/puma/
# the obj files can be downloaded there, and may be included in emc2 later

# link description
# link1 - stationary base
# link2 .. link7 - the 6 moving parts of the robot, numbered form base to end effector

from vismach import *
import hal

c = hal.component("puma560gui")
c.newpin("joint1", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint2", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint3", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint4", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint5", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint6", hal.HAL_FLOAT, hal.HAL_IN)
c.ready()


# units are mm

work = Capture()

#tool goes here.. maybe later
tool = Capture()

# "tooltip" for backplot will be the tip of the tool, for now platform
tooltip = Capture()
tool = Collection([tooltip, tool])


# ######################---movingplatform---######################

movingplatform = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/movingplatform-1.STL")

movingplatform = Color([0,1,0,0],[movingplatform])
movingplatform = Collection([movingplatform, tool])

###############wholeframe
#wholeframe = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/zhuangpeiti1.STL")

# ######################---fixedplatform---######################

fixedplatform = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/fixedframe1-1.STL")

fixedplatform = Color([0,1,0,0],[fixedplatform])
fixedplatform = Collection([fixedplatform])


####stick1########################

stick1 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-1.STL")

stick1 = Color([1,0,0,0],[stick1])
stick1 = Collection([stick1])

####stick2########################

stick2 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-2.STL")

stick2 = Color([1,0,0,0],[stick2])
stick2 = Collection([stick2])

####stick3########################

stick3 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-3.STL")

stick3 = Color([1,0,0,0],[stick3])
stick3 = Collection([stick3])

####stick4########################

stick4 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-4.STL")

stick4 = Color([1,0,0,0],[stick4])
stick4 = Collection([stick4])

####stick5########################

stick5 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-5.STL")

stick5 = Color([1,0,0,0],[stick5])
stick5 = Collection([stick5])

####stick6########################

stick6 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-3/stick-6.STL")

stick6 = Color([1,0,0,0],[stick6])
stick6 = Collection([stick6])

#,stick3,stick4,stick5,stick6 fixedplatform,
stick = Collection([stick3,stick4])
# stationary base
puma = Collection([fixedplatform])

model = Collection([tooltip, puma, work])


main(model, tooltip, work, 1000 )
